<?php
/**
* @package SimpleCaddy 1.75 for Joomla 1.7
* @copyright Copyright (C) 2006-2011 Henk von Pickartz. All rights reserved.
*/
// ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class com_caddyInstallerScript
{
function install() {
	$db=JFactory::getDBO();
    $mainframe=JFactory::getApplication();   
    $iq=array();
    $iq[]="DROP TABLE IF EXISTS `#__sc_config`;";
    $iq[]="CREATE TABLE IF NOT EXISTS `#__sc_config` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `keyword` varchar(32) NOT NULL,
  `description` varchar(255) NOT NULL,
  `setting` text NOT NULL,
  `cfgset` int(11) NOT NULL DEFAULT '0',
  `type` enum('text','textarea','richtext','yesno','list') NOT NULL,
  `indopts` text NOT NULL,
  `sh` int(11) NOT NULL,
  `sv` int(11) NOT NULL,
  `pagename` varchar(32) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `kw` (`keyword`)
);";
    $iq[]="CREATE TABLE IF NOT EXISTS `#__sc_fields` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(32) NULL,
  `caption` varchar(255) NULL,
  `type` varchar(16) NULL,
  `length` int(11) NULL,
  `classname` varchar(64)  NULL,
  `required` int(11) NULL,
  `ordering` int(11) NULL,
  `published` int(11) NULL,
  `checkfunction` varchar(64) NULL,
  `fieldcontents` text NULL,
  PRIMARY KEY (`id`)
);";
    
    $iq[]="CREATE TABLE IF NOT EXISTS `#__sc_odetails` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `orderid` int(11) NULL,
  `prodcode` varchar(10)  NULL,
  `qty` int(11)  NULL,
  `unitprice` float  NULL,
  `total` float  NULL,
  `shorttext` varchar(255)  NULL,
  `option` varchar(32)  NULL,
  PRIMARY KEY (`id`)
);";

    $iq[]="CREATE TABLE IF NOT EXISTS `#__sc_orders` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255)  NULL,
  `email` varchar(255)  NULL,
  `address` text  NULL,
  `codepostal` varchar(15)  NULL,
  `city` varchar(32)  NULL,
  `telephone` varchar(32)  NULL,
  `ordercode` varchar(32)  NULL,
  `ipaddress` varchar(16)  NULL,
  `customfields` text  NULL,
  `orderdt` int(11)  NULL,
  `total` float  NULL,
  `status` varchar(16)  NULL,
  `tax` float  NULL,
  `archive` int(11)  NULL,
  `shipCost` varchar(10)  NULL,
  `shipRegion` varchar(255)  NULL,
  `j_user_id` int(11)  NULL,
  PRIMARY KEY (`id`)
);";
  
    $iq[]="CREATE TABLE IF NOT EXISTS `#__sc_products` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `prodcode` varchar(13)  NULL,
  `shorttext` varchar(255)  NULL,
  `av_qty` int(11)  NULL,
  `unitprice` float  NULL,
  `published` int(11)  NULL,
  `optionstitle` varchar(32)  NULL,
  `options` text  NULL,
  `showas` int(11)  NULL,
  `category` varchar(255)  NULL,
  `shippoints` varchar(10)  NULL,
  PRIMARY KEY (`id`)
);";
    
    $iq[]="CREATE TABLE IF NOT EXISTS `#__sc_ship_zones` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(100)  NULL,
  `points_lower` float  NULL,
  `price` varchar(100)  NULL,
  `points_upper` float  NULL,
  PRIMARY KEY (`id`)
);";

    $iq[]="CREATE TABLE IF NOT EXISTS `#__sc_vouchers` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255)  NULL,
  `formula` varchar(255)  NULL,	
  `avqty` int(11)  NULL,
  `qtylimited` int(11)  NULL,
  `validfrom` int(11)  NULL,
  `validto` int(11)  NULL,
  `datelimited` int(11)  NULL,
  `published` int(11)  NULL,
  `lot` varchar(32)  NULL,
  PRIMARY KEY (`id`)
);
";
    
    $iq[]="CREATE TABLE IF NOT EXISTS `#__sc_prodoptiongroups` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `prodcode` varchar(32) NOT NULL,
  `title` varchar(255) NOT NULL,
  `showas` int(11) NOT NULL,
  `disporder` int(11) NOT NULL,
  PRIMARY KEY (`id`)
);";

    $iq[]="CREATE TABLE IF NOT EXISTS `#__sc_productoptions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `optgroupid` int(11) NOT NULL,
  `description` varchar(255) NOT NULL,
  `formula` varchar(255) NOT NULL,
  `caption` varchar(255) NOT NULL,
  `defselect` int(11) NOT NULL,
  `disporder` int(11) NOT NULL,
  PRIMARY KEY (`id`)
);";

    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(1, 'currency', 'CURRENCY_SYMBOL', 'CAD', 0, 'text', '', 0, 0, 'FINANCE');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(2, 'show_emptycart', 'SHOW_EMPTY_CART_BUTTON', '1', 0, 'yesno', '', 0, 0, 'FRONTEND_DISPLAY');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(3, 'thousand_sep', 'THOUSANDS_SEPARATOR', ',', 0, 'text', '', 0, 0, 'FRONTEND_DISPLAY');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(4, 'decimal_sep', 'DECIMAL_SEPARATOR', '.', 0, 'text', '', 0, 0, 'FRONTEND_DISPLAY');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(5, 'decimals', 'NUMBER_OF_DECIMALS', '2', 0, 'text', '', 0, 0, 'FRONTEND_DISPLAY');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(6, 'remove_button', 'SHOW_REMOVE_BUTTON', '1', 0, 'yesno', '', 0, 0, 'FRONTEND_DISPLAY');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(7, 'email_customer', 'SEND_CONFIRMATION_EMAIL_TO_CUSTOMER', '1', 0, 'yesno', '', 0, 0, 'COMMUNICATION');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(8, 'email_copies', 'SEND_CONFIRMATION_EMAIL_COPIES_TO', 'me@mysite.com\r\nyou@mysite.com', 0, 'textarea', '', 40, 10, 'COMMUNICATION');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(9, 'curralign', 'CURRENCY_SYMBOL_POSITION', '0', 0, 'list', 'Before amount:1\r\nAfter amount:0', 0, 0, 'FRONTEND_DISPLAY');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(10, 'ostatus', 'ORDER_STATUSES_ONE_PER_LINE', 'New\r\nReviewed\r\nReview\r\nCancelled\r\nTreated\r\nArchive', 0, 'textarea', '', 20, 10, 'ORDER_STATUSES');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(11, 'taxrate', 'TAX_RATE_TO_APPLY', '0', 0, 'text', '', 0, 0, 'FINANCE');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(12, 'emailhtml', 'EMAIL_IS_IN_HTML_FORMAT', '0', 0, 'yesno', '', 0, 0, 'COMMUNICATION');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(13, 'dateformat', 'DATE_FORMAT', 'd-m-y', 0, 'text', '', 0, 0, 'FRONTEND_DISPLAY');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(14, 'timeformat', 'TIME_FORMAT', 'h:i:s', 0, 'text', '', 0, 0, 'FRONTEND_DISPLAY');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(15, 'reselleremail', 'RESELLER_EMAIL_FOR_PAYPAL', 'change@me.com', 0, 'text', '', 40, 0, 'PAYPAL');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(16, 'usepaypal', 'USE_PAYPAL_FOR_CHECKOUT', '1', 0, 'yesno', '', 0, 0, 'PayPal');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(17, 'paypalcurrency', 'PAYPAL_CURRENCY', 'CAD', 0, 'list', 'Australian Dollars (AUD):AUD \r\nCanadian Dollars (CAD):CAD \r\nEuros (EUR):EUR \r\nPounds Sterling (GBP):GBP \r\nYen (YEN):JPY \r\nU.S. Dollars (USD):USD \r\nNew Zealand Dollar (NZD):NZD \r\nSwiss Franc:CHF \r\nHong Kong Dollar (HKD):HKD \r\nSingapore Dollar (SGD):SGD \r\nSwedish Krona:SEK \r\nDanish Krone:DKK \r\nPolish Zloty:PLN \r\nNorwegian Krone:NOK \r\nHungarian Forint:HUF \r\nCzech Koruna:CZK \r\nMexican Pesos:MXN \r\nSouth African Rand:R', 0, 0, 'PAYPAL');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(18, 'usecidasemail', 'USE_CONTENT_AS_EMAIL', '0', 0, 'yesno', '', 0, 0, 'COMMUNICATION');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(19, 'usestdproduct', 'USE_THE_SYSTEMATIC_PRODUCT', '0', 0, 'yesno', '', 10, 0, 'FINANCE');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(20, 'emailcid', 'CONFIRMATION_CONTENT_ID', '0', 0, 'text', '', 3, 0, 'COMMUNICATION');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(21, 'cart_fee_product', 'SYSTEMATIC_PRODUCT_CODE_TO_ADD_TO_CART', 'extracost', 0, 'text', '', 10, 0, 'FINANCE');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(22, 'prodcats', 'PRODUCT_CATEGORIES_ONE_PER_LINE', 'Food\r\nDrinks\r\nPlants\r\nChemistry\r\nNon-Food', 0, 'textarea', '', 40, 5, 'PRODUCT_CATEGORIES');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(23, 'ppreturnsuccess', 'PAYPAL_SUCCESS_RETURN_URL', '', 0, 'text', '', 80, 0, 'PAYPAL');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(24, 'ppreturncancel', 'PAYPAL_FAILURECANCEL_RETURN_URL', '', 0, 'text', '', 80, 0, 'PAYPAL');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(25, 'pgclassname', 'PAYMENT_GATEWAY_CLASSNAME', 'scpaypal', 0, 'text', '', 0, 0, 'PAYMENT_GATEWAY');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(26, 'mailengine', 'MAIL_ENGINE', 'joomla', 0, 'list', 'Joomla:joomla\r\nAlternative:alternative', 0, 0, 'COMMUNICATION');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(27, 'shippingenabled', 'IF_ENABLED_SHIPPING_ADDON_WILL_BE_USED_TO_CALCULATE_SHIPPING_COST', '0', 0, 'yesno', '', 0, 0, 'SHIPPING');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(28, 'checkminqty', 'CHECK_MINIMUM_QUANTITY_IN_DB', '0', 0, 'yesno', '', 0, 0, 'CHECKING_OUT');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(29, 'mincheckout', 'MINIMUM_AMOUNT_FOR_CHECKOUT', '0', 0, 'text', '', 0, 0, 'CHECKING_OUT');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(30, 'usevouchers', 'USE_THE_VOUCHERS', '0', 0, 'yesno', '', 0, 0, 'CHECKING_OUT');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(31, 'pretextid', 'CONTENT_ID_ABOVE_CART_DISPLAY', '0', 0, 'text', '', 0, 0, 'FRONTEND_DISPLAY');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(32, 'posttextid', 'CONTENT_ID_BELOW_CART_DISPLAY', '0', 0, 'text', '', 0, 0, 'FRONTEND_DISPLAY');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(36, 'email_fromname', 'SEND_EMAIL_FROM_NAME', '', 0, 'text', '', 40, 10, 'COMMUNICATION');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(37, 'email_fromname', 'SEND_EMAIL_FROM', '', 0, 'text', '', 40, 10, 'COMMUNICATION');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(33, 'whopaystax', 'WHO_PAYS_TAX', 'special', 0, 'list', 'Everybody:all\r\nSpecific destinations:special\r\nNobody:none\r\n', 0, 0, 'FINANCE');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(34, 'taxpays', 'SPECIFIC_TAX_DESTINATIONS', 'SK:10\r\nBC:15\r\nMB:20', 0, 'textarea', '', 60, 10, 'FINANCE');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(35, 'taxonshipping', 'PAY_TAX_ON_SHIPPING', '0', 0, 'yesno', '', 0, 0, 'FINANCE');";
    $iq[]="INSERT IGNORE INTO `#__sc_config` VALUES(38, 'ppenvironment', 'ENVIRONMENT', '0', 0, 'list', 'Production:0\r\nSandbox:1', 0, 0, 'PAYPAL');";

	foreach ($iq as $key=>$query) {
		$db->setquery($query);
		$db->query();
	}

/**      
	$query="show columns from #__sc_orders";
	$db->setQuery($query);
	$lstcf=$db->loadObjectList();
	$customfield=false;
	$ipaddress=false;
	$archive=false;
	$shipcost=false;
	$shipregion=false;
	$juserid=false;
	foreach ($lstcf as $f) {
		if ($f->Field=='customfields') {
			$customfield=true;
			if ($f->Type=="varchar(255)") {
				// change the field type
				$query="ALTER TABLE `#__sc_orders` CHANGE `customfields` `customfields` TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NULL;";
				$db->setQuery($query);
				$db->query();
				$customfield=true;
				echo "Changing customfields type to TEXT; <br />";
			}
		}
		if ($f->Field=='ipaddress') {
			$ipaddress=true;
		}
		if ($f->Field=='archive') {
			$archive=true;
		}
		if ($f->Field=='shipCost') {
			$shipcost=true;
		}
		if ($f->Field=='shipRegion') {
			$shipregion=true;
		}
		if ($f->Field=='j_user_id') {
			$juserid=true;
		}
	}
	if (!$archive) {
		// add the customfield
		$query="ALTER TABLE `#__sc_orders` ADD  `archive` INT(11) NULL;";
		$db->setQuery($query);
		$db->query();
		echo "Adding archive to database";
	}
	if (!$customfield) {
		// add the customfield
		$query="ALTER TABLE `#__sc_orders` ADD  `customfields` TEXT NULL;";
		$db->setQuery($query);
		$db->query();
		echo "Adding customfields to database";
	}
	if (!$ipaddress) {
		// add the customfield
		$query="ALTER TABLE `#__sc_orders` ADD  `ipaddress` varchar(32) NULL;";
		$db->setQuery($query);
		$db->query();
		echo "Adding ipaddress to database";
	}
	if (!$shipcost) {
		// add the customfield
		$query="ALTER TABLE `#__sc_orders` ADD  `shipCost` varchar(10) NULL;";
		$db->setQuery($query);
		$db->query();
		echo "Adding shipping cost to database";
	}
	if (!$shipregion) {
		// add the customfield
		$query="ALTER TABLE `#__sc_orders` ADD  `shipRegion` varchar(255) NULL;";
		$db->setQuery($query);
		$db->query();
		echo "Adding shipping region to database";
	}
	if (!$juserid) {
		// add the customfield
		$query="ALTER TABLE `#__sc_orders` ADD  `j_user_id`  int(11) NULL DEFAULT NULL;";
		$db->setQuery($query);
		$db->query();
		echo "Adding userid to orders table";
	}
    

	$db=JFactory::getDBO();
	$query="show columns from #__sc_fields";
	$db->setQuery($query);
	$lstcf=$db->loadObjectList();
	$fieldcontents=false;
	foreach ($lstcf as $f) {
		if ($f->Field=='fieldcontents') {
			$fieldcontents=true;
		}
	}
	if (!$fieldcontents) {
		// add the customfield
		$query="ALTER TABLE `#__sc_fields` ADD  `fieldcontents` TEXT NULL;";
		$db->setQuery($query);
		$db->query();
		echo "Adding fieldcontents to database";
	}
*/

// fill in the standard custom fields
	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(1, 'name', 'Name', 'text', 60, 'inputbox', 0, 0, 1, 'checkfilled', '');";
	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(2, 'address', 'Address', 'textarea', 0, 'inputbox', 1, 3, 1, 'checkfilled', '');";
	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(3, 'codepostal', 'Postal code / Zipcode', 'text', 10, 'inputbox', 0, 4, 1, 'checkfilled', '');";
	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(10, 'deliverybefore', 'Deliver before', 'date', 0, 'inputbox', 1, 99, 1, 'checkfilled', '');";
	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(5, 'city', 'City', 'text', 40, 'inputbox', 0, 5, 1, 'checkfilled', '');";
	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(6, 'telephone', 'Phone', 'text', 40, 'inputbox', 0, 15, 1, 'checkfilled', '');";
	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(7, 'email', 'Email', 'text', 40, 'inputbox', 0, 20, 1, 'checkfilled', '');";
	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(8, 'dropdown', 'My Dropdown Field', 'dropdown', 0, 'inputbox', 1, 0, 1, 'checkfilled', 'een;twee;drie;vier;vijf');";
	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(11, 'div1', 'Extra info', 'divider', 0, 'divider', 0, 10, 1, 'checkfilled', '');";
	$q[]="INSERT IGNORE INTO `#__sc_fields` VALUES(12, 'coupon', 'Enter coupon (if any)', 'voucher', 0, 'inputbox', 0, 0, 1, 'checkfilled', '');";
// add new fields to the config table
    $q[]="INSERT IGNORE INTO `#__sc_config` VALUES (36, 'email_fromname',  'Send email from name',  '".$mainframe->getCfg('fromname')."',  '0',  'text',  '',  '40',  '10',  'Communication');";
    $q[]="INSERT IGNORE INTO `#__sc_config` VALUES (37, 'email_fromname',  'Send email from',  '".$mainframe->getCfg('mailfrom')."',  '0',  'text',  '',  '40',  '10',  'Communication');";
    $q[]="INSERT IGNORE INTO `#__sc_config` VALUES (32, 'posttextid', 'Content ID below cart display', '0', 0, 'text', '', 0, 0, 'Frontend Display');";
    $q[]="INSERT IGNORE INTO `#__sc_config` VALUES (33, 'whopaystax', 'Who pays tax', 'special', 0, 'list', 'Everybody:all\r\nSpecific destinations:special\r\nNobody:none\r\n', 0, 0, 'Finance');";
    $q[]="INSERT IGNORE INTO `#__sc_config` VALUES (34, 'taxpays', 'Specific tax destinations', 'SK:10\r\nBC:15\r\nMB:20', 0, 'textarea', '', 60, 10, 'Finance');";
    $q[]="INSERT IGNORE INTO `#__sc_config` VALUES (35, 'taxonshipping', 'Pay tax on shipping', '0', 0, 'yesno', '', 0, 0, 'Finance');";
	


	foreach ($q as $key=>$query) {
		$db->setquery($query);
		$db->query();
	}

	$db=JFactory::getDBO();
	$query="show columns from #__sc_products";
	$db->setQuery($query);
	$lstcf=$db->loadObjectList();
	$shippoints=false;
	foreach ($lstcf as $f) {
		if ($f->Field=='shippoints') {
			$shippoints=true;
		}
	}
	if (!$shippoints) {
		// add the customfield
		$query="ALTER TABLE `#__sc_products` ADD  `shippoints` INT(11);";
		$db->setQuery($query);
		$db->query();
		echo "Adding Shipping points to database";
	}


}
}
?>