<?php
/**
 * @version $Id: view.html.php 44797 2011-11-06 04:26:19Z steph $
 * @author RocketTheme, LLC http://www.rockettheme.com
 * @copyright Copyright (C) 2007 - 2012 RocketTheme, LLC
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );
require_once JPATH_COMPONENT.'/helpers/rokquickcart.php';

jimport('joomla.application.component.view');

/**
 * @package     RocketTheme
 * @subpackage  rokquickcart.views.rokquickcart
 */
class rokquickcartViewcartitems extends JView
{
	protected $items;
	protected $pagination;
	protected $state;

	/**
	 * Display the view
	 *
	 * @return	void
	 */
	public function display($tpl = null)
	{
        $doc        =& JFactory::getDocument();
        
		$this->items		= $this->get('Items');
		$this->pagination	= $this->get('Pagination');
		$this->state		= $this->get('State');

		// Check for errors.
		if (count($errors = $this->get('Errors'))) {
			JError::raiseError(500, implode("\n", $errors));
			return false;
		}

		// Preprocess the list of items to find ordering divisions.
		foreach ($this->items as &$item) {
			$item->order_up = true;
			$item->order_dn = true;
		}

        $doc->addStyleSheet('components/com_rokquickcart/assets/rokquickcart.css');

        $this->assignRef('image', $this->item->image);

		$this->addToolbar();

		parent::display($tpl);
	}

	/**
	 * Add the page title and toolbar.
	 *
	 * @since	1.6
	 */
	protected function addToolbar()
	{
        $state	= $this->get('State');
        $canDo	= RokQuickCartHelper::getActions();
		$user	= JFactory::getUser();
		JToolBarHelper::title(JText::_('ROKQUICKCART_MANAGER_ITEMS'), 'rokquickcart.png');

		if ($canDo->get('core.create') || (count($user->getAuthorisedCategories('com_rokquickcart', 'core.create'))) > 0) {
			JToolBarHelper::addNew('cartitem.add');
		}

		if (($canDo->get('core.edit')) || ($canDo->get('core.edit.own'))) {
			JToolBarHelper::editList('cartitem.edit');
		}

		if ($canDo->get('core.edit.state')) {
			JToolBarHelper::divider();
			JToolBarHelper::publish('cartitems.publish', 'JTOOLBAR_PUBLISH', true);
			JToolBarHelper::unpublish('cartitems.unpublish', 'JTOOLBAR_UNPUBLISH', true);
			JToolBarHelper::divider();
			JToolBarHelper::checkin('cartitems.checkin');
		}

		if ($state->get('filter.state') == -2 && $canDo->get('core.delete')) {
			JToolBarHelper::divider();
			JToolBarHelper::deleteList('', 'cartitems.delete','JTOOLBAR_EMPTY_TRASH');
		} else if ($canDo->get('core.edit.state')) {
			JToolBarHelper::divider();
			JToolBarHelper::trash('cartitems.trash');
		}

		if ($canDo->get('core.admin')) {
			JToolBarHelper::preferences('com_rokquickcart');
			JToolBarHelper::divider();
		}

		JToolBarHelper::help('JHELP_COMPONENTS_ROKQUICKCART');
	}

}